BASE_DIR=/home/mitarb/rehbein/test
SCRIPTS_DIR=$BASE_DIR/scripts
RESOURCES_DIR=$BASE_DIR/resources
OUT_DIR=$BASE_DIR/converted

INFILE=$1
OUTFILE=$2

TRANSFORMATION=CoordTransformation
DIRECTION=tig-ud

#####
# run with:
# python3 $SCRIPTS_DIR/convert.py <transform_class> <direction> <infile-prefix> <outfile-prefix>
#
# where <transform_class> is either CoordTransformation, PrepTransformation or PDCopTransformation
# <direction> is either tig-ud or ud-tig (where tig stands for function-head and ud for content-head relations)
# <infile-prefix> specifies the prefix for the infile, e.g. for the file "tiger-stts.tags-gold+parses-gold.dev.conll"
# => prefix:  "tiger-stts.tags-gold+parses-gold"
# <outfile-prefix> => see infile-prefix

SPLITS=("train" "dev" "test")
for split in "${SPLITS[@]}"
do
	        python3 $SCRIPTS_DIR/convert.py $TRANSFORMATION $DIRECTION $RESOURCES_DIR/$INFILE.${split}.conll $OUT_DIR/$OUTFILE.${split}.conll
done



