from lingres.conll import read_conll09_file, write_conll09_file

import sys

def extract_sentence_to_match_token_count(sentences, target_token_count):
    curr_tok_count = 0
    while curr_tok_count < target_token_count:
        next_sent = next(sentences)
        yield next_sent
        curr_tok_count += len(next_sent)

if __name__ == "__main__":
    sentences = read_conll09_file(sys.argv[1])
    target_num_tokens = int(sys.argv[3])

    extracted_sentences = extract_sentence_to_match_token_count(sentences, target_num_tokens)

    write_conll09_file(sys.argv[2], extracted_sentences)


