from lingres.tabular import TabularReader, TabularWriter

import sys
import math
import itertools as it
from argparse import ArgumentParser

def count(it):
    counter = 0
    for item in it:
        counter += 1

    return counter

def parse_args():
    parser = ArgumentParser()
    parser.add_argument("infile")
    parser.add_argument("outprefix")
    parser.add_argument("-s", "--size", type = int)
    parser.add_argument("-n", "--number", type = int)

    return parser.parse_args()

def chunksplit_main():
    options = parse_args()
    #n_sents = int(sys.argv[3])

    reader = TabularReader(options.infile)
    file_idx = 0

    read_sentence = reader.read_sentences()

    if options.size:
        file_sent_cnts = it.repeat([options.size])
    elif options.number:
        total_file_size = count(reader.read_sentences())
        sents_per_doc = int(math.floor(total_file_size / options.number))
        remainder = total_file_size - (sents_per_doc * options.number)
        file_sent_cnts = [sents_per_doc + 1 for _ in range(remainder)] + [
                sents_per_doc for _ in range(options.number - remainder)
                ]
        print(total_file_size, sum(file_sent_cnts))


    for n_sents in file_sent_cnts:
        curr_writer = TabularWriter("{}.{}".format(options.outprefix, file_idx))
        for idx, sent in enumerate(read_sentence):
            curr_writer.write_sentence(sent)
            if idx == n_sents - 1:
                break
        else:
            break

        curr_writer.close()
        file_idx += 1



