import sys

from lingres.decoding import MultiValueFieldDecoder
from lingres.tabular import TabularReader, TabularWriter

def fix_ud_encoding(values, desired_num_vals, sep):
    return values[0] + sep + values[1], values[2]

def decode_main():
    reader = TabularReader(sys.argv[1])
    
    writers = [TabularWriter(fname) for fname in sys.argv[2:]]
    decoder = MultiValueFieldDecoder(len(writers), ambigous_sep_refitter = fix_ud_encoding)

    for sents in decoder.decode_sentences(reader.read_sentences()):
        for sent, writer in zip(sents, writers):
            writer.write_sentence(sent)
    
    for writer in writers:
        writer.close()


