from lingres.conll import read_conll09_file
import sys
from collections import Counter, defaultdict

def eval_tree_pos_tags(gold_sentences, system_setences):
    confusion_counters = defaultdict(Counter)
    for gold_sent, sys_sent in zip(gold_sentences, system_setences):
        for gold_tok, sys_tok in zip(gold_sent, sys_sent):
            confusion_counters[gold_tok.pos][sys_tok.pos] += 1

    correct_classification_count = 0
    total_sample_count = 0
    for pos, confusion_counter in confusion_counters.items():
        correct_classification_count += confusion_counters[pos][pos]
        total_sample_count += sum(confusion_counter.values())

    print(correct_classification_count/total_sample_count)



if __name__ == "__main__":
    gold_trees = read_conll09_file(sys.argv[1])
    sys_trees = read_conll09_file(sys.argv[2])

    eval_tree_pos_tags(gold_trees, sys_trees)

